package Oracle
  model ResistorExperiment
  Modelica.Electrical.Analog.Basic.Resistor resistor(R = 2)  annotation(
      Placement(transformation(origin = {-20, 30}, extent = {{-10, -10}, {10, 10}})));
  Modelica.Electrical.Analog.Sensors.CurrentSensor currentSensor annotation(
      Placement(transformation(origin = {10, 30}, extent = {{-10, -10}, {10, 10}})));
  Modelica.Electrical.Analog.Sources.TrapezoidVoltage battery(V = 4, rising = 1, width = 5, falling = 1, period = 7, nperiod = 1, startTime = 2)  annotation(
      Placement(transformation(origin = {-4, 0}, extent = {{-10, -10}, {10, 10}})));
  Modelica.Electrical.Analog.Basic.Ground ground annotation(
      Placement(transformation(origin = {20, -20}, extent = {{-10, -10}, {10, 10}})));
  equation
  connect(currentSensor.p, resistor.n) annotation(
      Line(points = {{0, 30}, {-10, 30}}, color = {0, 0, 255}));
  connect(battery.p, resistor.p) annotation(
      Line(points = {{-14, 0}, {-44, 0}, {-44, 30}, {-30, 30}}, color = {0, 0, 255}));
  connect(battery.n, currentSensor.n) annotation(
      Line(points = {{6, 0}, {30, 0}, {30, 30}, {20, 30}}, color = {0, 0, 255}));
  connect(ground.p, battery.n) annotation(
      Line(points = {{20, -10}, {20, 0}, {6, 0}}, color = {0, 0, 255}));
  annotation(
      __OpenModelica_simulationFlags(lv = "LOG_STDOUT,LOG_ASSERT,LOG_STATS", s = "dassl", variableFilter = ".*"));
end ResistorExperiment;
  annotation(
    uses(Modelica(version = "4.0.0")));
end Oracle;
