from .query.query import run
from .utils import add_submodule
from .query import supplied_voltage

# Submodule must be added before importing the metamodel code
add_submodule("muMLE")
from .muMLE.api.od import build_name_mapping

from .model.model import Model
from .transformation.rule_base_runner import RuleBaseRunner

if __name__ == "__main__":
    meta_model = Model("meta_model.od")
    meta_model.conform()

    start_model = Model("../whiteboard/start_model.od", meta_model=meta_model.get(), state=meta_model.state)
    start_model.conform()
    start_model.get_uml("Start model")

    runner = RuleBaseRunner(start_model.state, start_model.get(), meta_model.get())
    runner.run()

# if __name__ == '__main__':
#     supplied_voltage.get_supplied_voltage("http://msdl.uantwerpen.be/experiment/description/experiments/experiment1#instrumented1_r1_interface2")

# if __name__ == '__main__':
#     run()
