from janus_swi import *
from ..query.utils import load_knowledge_graph

def perform_query(q):
    with query(q) as result:
        while s := result.next():
            yield s

    return []

def get_individual_of(namespace, agg_elem):
    full_query = f"semweb:rdfs:rdfs_individual_of(I, '{namespace}#{agg_elem}')"
    return [result['I'] for result in perform_query(full_query)]

def get_properties_and_values(named_individual):
    full_query = f"semweb:rdfs:rdf_has('{named_individual}', P, O)"
    print(f"Query: {full_query}")
    for result in perform_query(full_query):
        print(f"\tProperty: {result['P']} Value: {result['O']}")

    return [(result['P'], result['O']) for result in perform_query(full_query)]

def ask_name(predicate):
    namespace = f"{predicate}vocabulary/core/experiment"
    aggregated_element = "ExperimentSpecification"
    return get_individual_of(namespace, aggregated_element)[0]

def ask_sus(named_individual):

    results = []
    for p, o in get_properties_and_values(named_individual):
        if 'hasSpecifiedSystemUnderStudy' in p:
            results.append(o)

    return results

def run_queries(predicate):
    name = ask_name(predicate)
    print(name)
    # ask_sus(name)

def run():
    predicate = "http://msdl.uantwerpen.be/experiment/"

    load_knowledge_graph()
    run_queries(predicate)
