from janus_swi import *
import os

def get_cur_dir():
    return os.path.dirname(os.path.abspath(__file__))

def load_knowledge_graph():
    consult(f"{get_cur_dir()}/prolog/load")
    query_once("load:load_ontology")  # Ensures the RDF data is loaded

def load_rdf_query_utils():
    consult(f"{get_cur_dir()}/prolog/rdf_query_utils")

def get_value_and_unit(uri: str, quantity_value: str):
    result = query_once(f"rdf_query_utils:get_value_and_unit('{uri}', '{quantity_value}', Value, Unit).")

    if result['truth']:
        result.pop('truth')
        return result
    return None

def execute_query(q):
    with query(q) as result:
        while s := result.next():
            yield s
        result.close()

    return []
