import uuid

from ..muMLE.api.od import ODAPI
from ..muMLE.concrete_syntax.plantuml.renderer import render_class_diagram
from ..muMLE.state.devstate import DevState
from ..muMLE.transformation.ramify import ramify
from ..model.model import Model
from ..transformation.rule_loader import RuleLoader
from ..transformation.simulator import Simulator


class RuleBaseRunner:
    def __init__(self, state: DevState, model: uuid.UUID, meta_model: uuid.UUID):
        rt_mm_ramified = ramify(state, meta_model)
        rule_loader = RuleLoader(state, rt_mm_ramified)
        rules = rule_loader.load([
            "00_setup_systems",
            "10_connect_through",
            "11_connect_across",
            "20_clean_up",
            "21_clean_up_links",
            # "30_wire_up"
        ])

        self.simulator = Simulator(state, model, meta_model, rt_mm_ramified, rules)

    def run(self):
        self.simulator.run(show_every_step=True)
