import os

from ..muMLE.util import loader


class RuleLoader:
    def __init__(self, state, ramified_model):
        self.state = state
        self.ramified_model = ramified_model

    @staticmethod
    def get_rule_path(rule_name, kind):
        return f"{os.path.dirname(__file__)}/rules/r_{rule_name}_{kind}.od"

    def load(self, rule_names=None):
        if rule_names is None:
            rule_names = []
        return loader.load_rules(
            self.state,
            self.get_rule_path,
            self.ramified_model,
            rule_names,
        )
