import jinja2
import os
THIS_DIR = os.path.dirname(__file__)

from ...architecture.muMLE.api.od import ODAPI
from .. import helpers
from ...architecture.muMLE.util.module_to_dict import module_to_dict

def export_modelica(state, m, mm, model_name):
    loader = jinja2.FileSystemLoader(searchpath=THIS_DIR)
    environment = jinja2.Environment(loader=loader)
    template = environment.get_template("modelica.jinja2")
    return template.render({
        'odapi': ODAPI(state, m, mm),
        'model_name': model_name,
        **globals()['__builtins__'],
        **module_to_dict(helpers),
    })
