:- module(owl_interface, [
       change_class/2           % Change the class of an instance
   ]).

:- use_module(library(semweb/rdf11)).
:- use_module(library(semweb/rdf_turtle)).

% Change the class of an instance (removes old class membership and adds a new one)
change_class(Instance, NewClass) :-
    % First remove any old class membership
    rdf_retractall(Instance, rdf:type, _),
    % Add the new class membership
    rdf_assert(Instance, rdf:type, NewClass),
    format('Changed class of ~w to ~w~n', [Instance, NewClass]).

