from OMPython import OMCSessionZMQ
from OMPython import ModelicaSystem
import os

model_file = os.path.abspath("simulation/Oracle.mo")


mod = ModelicaSystem(model_file, "Oracle.ResistorExperiment", ["Modelica"])
mod.buildModel()

simulationOptions = {
    "startTime": 0.0,
    "stopTime": 20.0,
}

mod.setSimulationOptions([f"{key}={value}" for key, value in simulationOptions.items()])

print(f"Inputs:" + "".join([f"\n  - {key}: {value}" for key, value in mod.getInputs().items()]))
print(f"Outputs:" + "".join([f"\n  - {key}: {value}" for key, value in mod.getOutputs().items()]))
print(f"Parameters:" + "".join([f"\n  - {key}: {value}" for key, value in mod.getParameters().items()]))
print(f"Simulation options:" + "".join([f"\n  - {key}: {value}" for key, value in mod.getSimulationOptions().items()]))
mod.simulate()
print(f"Output parameters:" + "".join([f"\n  - {value}" for value in mod.getSolutions()]))

solutions = mod.getSolutions(["currentSensor.i"])

print([float(round(value, 2)) for value in solutions[0]])

# Create an OpenModelica session
# omc = OMCSessionZMQ()
# 
# model_file = os.path.abspath("simulation/Oracle.mo")
# 
# cmds = [
#     'loadModel(Modelica)',
#     f'loadFile("{model_file}")',
#     'getClassNames()',
#     'isPackage(Oracle)',
#     'isModel(Oracle.ResistorExperiment)',
#     'simulate(Oracle.ResistorExperiment)'
# ]
# 
# for cmd in cmds:
#     answer = omc.sendExpression(cmd)
#     print("\n{}: {}".format(cmd, answer))
# 
# 
